;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: Counter32_2.asm
;;   Version: 2.5, Updated on 2010/9/19 at 23:39:53
;;  Generated by PSoC Designer 5.1.1875.0
;;
;;  DESCRIPTION: Counter32 User Module software implementation file
;;
;;  NOTE: User Module APIs conform to the fastcall16 convention for marshalling
;;        arguments and observe the associated "Registers are volatile" policy.
;;        This means it is the caller's responsibility to preserve any values
;;        in the X and A registers that are still needed after the API functions
;;        returns. For Large Memory Model devices it is also the caller's 
;;        responsibility to perserve any value in the CUR_PP, IDX_PP, MVR_PP and 
;;        MVW_PP registers. Even though some of these registers may not be modified
;;        now, there is no guarantee that will remain the case in future releases.
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress Semiconductor 2010. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"
include "memory.inc"
include "Counter32_2.inc"

;-----------------------------------------------
;  Global Symbols
;-----------------------------------------------
export  Counter32_2_EnableInt
export _Counter32_2_EnableInt
export  Counter32_2_DisableInt
export _Counter32_2_DisableInt
export  Counter32_2_Start
export _Counter32_2_Start
export  Counter32_2_Stop
export _Counter32_2_Stop
export  Counter32_2_WritePeriod
export _Counter32_2_WritePeriod
export  Counter32_2_WriteCompareValue
export _Counter32_2_WriteCompareValue
export  Counter32_2_ReadCompareValue
export _Counter32_2_ReadCompareValue
export  Counter32_2_ReadCounter
export _Counter32_2_ReadCounter

;-----------------------------------------------
;  Constant Definitions
;-----------------------------------------------
INPUT_REG_CLOCK_MASK:          equ 0x0F    ; Input register clock mask
INPUT_REG_NULL:                equ 0x00    ; Clear the input register
INPUT_REG_PREV_MASK:           equ 0x30    ; input register input-previous


AREA UserModules (ROM, REL)

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: Counter32_2_EnableInt
;
;  DESCRIPTION:
;     Enables this counter's interrupt by setting the interrupt enable mask bit
;     associated with this User Module. This function has no effect until and
;     unless the global interrupts are enabled (for example by using the
;     macro M8C_EnableGInt).
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None.
;  RETURNS:      Nothing.
;  SIDE EFFECTS: 
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 Counter32_2_EnableInt:
_Counter32_2_EnableInt:
   RAM_PROLOGUE RAM_USE_CLASS_1
   Counter32_2_EnableInt_M
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret

.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: Counter32_2_DisableInt
;
;  DESCRIPTION:
;     Disables this counter's interrupt by clearing the interrupt enable
;     mask bit associated with this User Module.
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None
;  RETURNS:      Nothing
;  SIDE EFFECTS: 
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 Counter32_2_DisableInt:
_Counter32_2_DisableInt:
   RAM_PROLOGUE RAM_USE_CLASS_1
   Counter32_2_DisableInt_M
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret


.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: Counter32_2_Start
;
;  DESCRIPTION:
;     Sets the start bit in the Control register of this user module.  The
;     counter will begin counting on the next input clock as soon as the
;     enable input is asserted high.
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None
;  RETURNS:      Nothing
;  SIDE EFFECTS: 
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 Counter32_2_Start:                         
_Counter32_2_Start:                              
   RAM_PROLOGUE RAM_USE_CLASS_1
   Counter32_2_Start_M
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret


.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: Counter32_2_Stop
;
;  DESCRIPTION:
;     Disables counter operation by clearing the start bit in the Control
;     register of the LSB block.
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None
;  RETURNS:      Nothing
;  SIDE EFFECTS: 
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 Counter32_2_Stop:                          
_Counter32_2_Stop:
   RAM_PROLOGUE RAM_USE_CLASS_1
   Counter32_2_Stop_M
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret


.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: Counter32_2_WritePeriod
;
;  DESCRIPTION:
;     Write the 32-bit period value into the Period register (DR1).
;-----------------------------------------------------------------------------
;
;  ARGUMENTS: FASTCALL16 DWORD dwPeriodValue (placed on stack)
;  RETURNS:   Nothing
;  SIDE EFFECTS:
;    If the counter user module is stopped, then this value will also be
;    latched into the Count registers (DR0).
;    
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
_Counter32_2_WritePeriod:                   
 Counter32_2_WritePeriod:
   RAM_PROLOGUE RAM_USE_CLASS_2
   mov   X, SP                                   ; Set X to point to stack frame
   mov   A, [X-6]                                ; load the period registers
   mov   reg[Counter32_2_PERIOD_MSB_REG],  A
   mov   A, [X-5]
   mov   reg[Counter32_2_PERIOD_ISB2_REG], A
   mov   A, [X-4]
   mov   reg[Counter32_2_PERIOD_ISB1_REG], A
   mov   A, [X-3]
   mov   reg[Counter32_2_PERIOD_LSB_REG],  A
   RAM_EPILOGUE RAM_USE_CLASS_2
   ret


.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: Counter32_2_WriteCompareValue
;
;  DESCRIPTION:
;     Writes compare value into the Compare register (DR2).
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    FASTCALL16 DWORD dwCompareValue (placed on stack)
;  RETURNS:      Nothing
;  SIDE EFFECTS: 
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
_Counter32_2_WriteCompareValue:             
 Counter32_2_WriteCompareValue:
   RAM_PROLOGUE RAM_USE_CLASS_2
   mov   X, SP                                   ; Set X to point to stack frame
   mov   A, [X-6]                                ; load the compare registers
   mov   reg[Counter32_2_COMPARE_MSB_REG],  A
   mov   A, [X-5]
   mov   reg[Counter32_2_COMPARE_ISB2_REG], A
   mov   A, [X-4]
   mov   reg[Counter32_2_COMPARE_ISB1_REG], A
   mov   A, [X-3]
   mov   reg[Counter32_2_COMPARE_LSB_REG],  A
   RAM_EPILOGUE RAM_USE_CLASS_2
   ret


.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: Counter32_2_ReadCompareValue
;
;  DESCRIPTION:
;     Reads the Compare registers.
;-----------------------------------------------------------------------------
;
;  ARGUMENTS: FASTCALL16 DWORD * pdwCompareValue
;             (pointer: LSB in X, MSB in A is RAM Page (or N/A in the SMM)
;  RETURNS:   Nothing (but see Side Effects).
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;          
;    Currently only the page pointer registers listed below are modified: 
;          IDX_PP
;
;    The DWORD pointed to by X takes on the value read from DR2
;
;
 Counter32_2_ReadCompareValue:
_Counter32_2_ReadCompareValue:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_IDX A                             ; Set the variable page
   mov   A, reg[Counter32_2_COMPARE_MSB_REG]
   mov   [X+0], A
   mov   A, reg[Counter32_2_COMPARE_ISB2_REG]
   mov   [X+1], A
   mov   A, reg[Counter32_2_COMPARE_ISB1_REG]
   mov   [X+2], A
   mov   A, reg[Counter32_2_COMPARE_LSB_REG]
   mov   [X+3], A
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret


.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: Counter32_2_ReadCounter
;
;  DESCRIPTION:
;     Returns the value in the Count register (DR0), preserving the value in
;     the compare register (DR2). Interrupts are prevented during the transfer
;     from the Count to the Compare registers by holding the clock low in
;     the MSB PSoC block.
;-----------------------------------------------------------------------------
;
;  ARGUMENTS: FASTCALL16 DWORD * pdwCount
;             (pointer: LSB in X,  MSB in A is RAM Page (or N/A in the SMM ))
;  RETURNS:   Nothing (but see Side Effects).
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;          
;    Currently only the page pointer registers listed below are modified: 
;          IDX_PP
;
;    The DWORD pointed to by X takes on the value read from DR0
;    The user module is stopped momentarily and one or more counts may be missed.
;
 Counter32_2_ReadCounter:
_Counter32_2_ReadCounter:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_IDX A                             ; Set the variable page
   mov   A, reg[Counter32_2_CONTROL_LSB_REG]     ; Save CR0 (running or stopped state)
   push  A                                          ;
   mov   A, reg[Counter32_2_COMPARE_MSB_REG]     ; Save the current value of
   push  A                                          ;   the comparare register
   mov   A, reg[Counter32_2_COMPARE_ISB2_REG]    ;   on the stack...
   push  A                                          ;
   mov   A, reg[Counter32_2_COMPARE_ISB1_REG]    ;
   push  A                                          ;
   mov   A, reg[Counter32_2_COMPARE_LSB_REG]     ;
   push  A                                          ;   (stack frame now 4 bytes)
   Counter32_2_Stop_M                            ; Disable (stop) the Counter if running
   M8C_SetBank1                                     ;
   mov   A, reg[Counter32_2_INPUT_MSB_REG]       ; save the MSB clock setting on
   push  A                                          ;   the stack (now 5 bytes) and
                                                    ;   hold (only!) its clock low:
   mov   reg[Counter32_2_INPUT_MSB_REG], INPUT_REG_NULL
   M8C_SetBank0                                     ; Result <- Count
   mov   A, reg[Counter32_2_COUNTER_MSB_REG]     ;   DR2 <- DR0 (in the MSB block)
   mov   A, reg[Counter32_2_COMPARE_MSB_REG]     ;   Retrieve the Count MSB and...
   mov   [X+0], A                                   ;     update the result
   mov   A, reg[Counter32_2_COUNTER_ISB2_REG]    ;   etc, for ISB2
   mov   A, reg[Counter32_2_COMPARE_ISB2_REG]    ;
   mov   [X+1], A                                   ;
   mov   A, reg[Counter32_2_COUNTER_ISB1_REG]    ;   etc, for ISB1
   mov   A, reg[Counter32_2_COMPARE_ISB1_REG]    ;
   mov   [X+2], A                                   ;
   mov   A, reg[Counter32_2_COUNTER_LSB_REG]     ;   etc, for LSB
   mov   A, reg[Counter32_2_COMPARE_LSB_REG]     ;
   mov   [X+3], A                                   ;
   pop   X                                          ; Hold Input reg in X temporarily
   pop   A                                          ; Restore the 32-bit Compare
   mov   reg[Counter32_2_COMPARE_LSB_REG],  A    ;   register...
   pop   A                                          ;
   mov   reg[Counter32_2_COMPARE_ISB1_REG], A    ;
   pop   A                                          ;
   mov   reg[Counter32_2_COMPARE_ISB2_REG], A    ;
   pop   A                                          ;
   mov   reg[Counter32_2_COMPARE_MSB_REG],  A    ;
   M8C_SetBank1                                     ; Restore the counter operation:
   mov   A, X                                       ;   Grab the clock setting...
   mov   reg[Counter32_2_INPUT_MSB_REG], A       ;     and restore it
   M8C_SetBank0                                     ;   Re-enable (start) the counter...
   pop   A                                          ;     if it was running when
   mov   reg[Counter32_2_CONTROL_LSB_REG], A     ;     this function was first called
   RAM_EPILOGUE RAM_USE_CLASS_3                     ; Post function paging environment restore
   ret

.ENDSECTION

; End of File Counter32_2.asm
