;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: Counter32_2.inc
;;   Version: 2.5, Updated on 2010/9/19 at 23:39:53
;;  Generated by PSoC Designer 5.1.1875.0
;;
;;  DESCRIPTION: Assembler declarations for the Counter32 user module interface
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress Semiconductor 2010. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"


;--------------------------------------------------
; Constants for Counter32_2 API's.
;--------------------------------------------------

Counter32_2_CONTROL_REG_START_BIT:         equ 0x01    ; Control register start bit
Counter32_2_INT_REG:                       equ 0x0e1
Counter32_2_INT_MASK:                      equ 0x80


;--------------------------------------------------
; Constants for Counter32_2 user defined values
;--------------------------------------------------

Counter32_2_PERIOD:                        equ 0xffffffff
Counter32_2_COMPARE_VALUE:                 equ 0x0


;--------------------------------------------------
; Register Address Constants for Counter32_2
;--------------------------------------------------

Counter32_2_COUNTER_LSB_REG:           equ 0x30   ; DR0 Counter register
Counter32_2_COUNTER_ISB1_REG:          equ 0x34
Counter32_2_COUNTER_ISB2_REG:          equ 0x38
Counter32_2_COUNTER_MSB_REG:           equ 0x3c
Counter32_2_PERIOD_LSB_REG:            equ 0x31   ; DR1 Period register
Counter32_2_PERIOD_ISB1_REG:           equ 0x35
Counter32_2_PERIOD_ISB2_REG:           equ 0x39
Counter32_2_PERIOD_MSB_REG:            equ 0x3d
Counter32_2_COMPARE_LSB_REG:           equ 0x32   ; DR2 CompareValue register
Counter32_2_COMPARE_ISB1_REG:          equ 0x36
Counter32_2_COMPARE_ISB2_REG:          equ 0x3a
Counter32_2_COMPARE_MSB_REG:           equ 0x3e
Counter32_2_CONTROL_LSB_REG:           equ 0x33   ; Control register
Counter32_2_CONTROL_ISB1_REG:          equ 0x37
Counter32_2_CONTROL_ISB2_REG:          equ 0x3b
Counter32_2_CONTROL_MSB_REG:           equ 0x3f
Counter32_2_FUNC_LSB_REG:              equ 0x30   ; Function register
Counter32_2_FUNC_ISB1_REG:             equ 0x34
Counter32_2_FUNC_ISB2_REG:             equ 0x38
Counter32_2_FUNC_MSB_REG:              equ 0x3c
Counter32_2_INPUT_LSB_REG:             equ 0x31   ; Input register
Counter32_2_INPUT_ISB1_REG:            equ 0x35
Counter32_2_INPUT_ISB2_REG:            equ 0x39
Counter32_2_INPUT_MSB_REG:             equ 0x3d
Counter32_2_OUTPUT_LSB_REG:            equ 0x32   ; Output register
Counter32_2_OUTPUT_ISB1_REG:           equ 0x36
Counter32_2_OUTPUT_ISB2_REG:           equ 0x3a
Counter32_2_OUTPUT_MSB_REG:            equ 0x3e


;--------------------------------------------------
; Counter32_2 Macro 'Functions'
;--------------------------------------------------

   macro Counter32_2_Start_M
   or    reg[Counter32_2_CONTROL_LSB_REG],  Counter32_2_CONTROL_REG_START_BIT
   endm

   macro Counter32_2_Stop_M
   and   reg[Counter32_2_CONTROL_LSB_REG], ~Counter32_2_CONTROL_REG_START_BIT
   endm

   macro Counter32_2_EnableInt_M
   M8C_EnableIntMask Counter32_2_INT_REG, Counter32_2_INT_MASK
   endm

   macro Counter32_2_DisableInt_M
   M8C_DisableIntMask Counter32_2_INT_REG, Counter32_2_INT_MASK
   endm


; end of file Counter32_2.inc
